<?php
/**
* @copyright	Copyright (C) 2011 Simplify Your Web, Inc. All rights reserved.
* @license		GNU General Public License version 3 or later; see LICENSE.txt
*/

// no direct access
defined( '_JEXEC' ) or die;

// import library dependencies
jimport('joomla.plugin.plugin');

class plgSystemJqueryeasy extends JPlugin {

  public function __construct( &$subject, $config ) {

    parent::__construct( $subject, $config );

    $this->loadLanguage();

    $this->_jqpath = '';
    $this->_jquipath = '';
    $this->_jquicsspath = '';	
  } 

  function onAfterInitialise() {

    $app =& JFactory::getApplication();		
    $doc =& JFactory::getDocument();

    $jQueryVersion = $this->params->get('jqueryversion','1.7');
    $jQueryUIVersion = $this->params->get('jqueryuiversion','1.8.17');
    $jQueryUITheme = $this->params->get('jqueryuitheme','base');

    $jQueryInFrontend = $this->params->get('jqueryinfrontend',1);		
    $jQueryInBackend = $this->params->get('jqueryinbackend',0);
    
    $removeAlljQueryNoConflict = $this->params->get('removealljquerynoconflict', 1);
    $insertjQueryNoConflict = $this->params->get('insertjquerynoconflict', 1);
                                                                        
    $jQueryHTTP = $this->params->get('whichhttp','https');

    $this->_jqpath = $jQueryHTTP."://ajax.googleapis.com/ajax/libs/jquery/".$jQueryVersion."/jquery.min.js";
    $this->_jquipath = $jQueryHTTP."://ajax.googleapis.com/ajax/libs/jqueryui/".$jQueryUIVersion."/jquery-ui.min.js";
    $this->_jquicsspath = $jQueryHTTP."://ajax.googleapis.com/ajax/libs/jqueryui/".$jQueryUIVersion."/themes/".$jQueryUITheme."/jquery-ui.css";

    // abandonned http://code.jquery.com/
    // could also use http://www.asp.net/ajaxlibrary/cdn.ashx

    if ($app->isAdmin() && $jQueryInBackend == 0) {
      return;
    }

    if ($jQueryInFrontend != 0 || ($app->isAdmin() && $jQueryInBackend != 0)) { // use jQuery		
      // Load MooTools first
      JHTML::_(' behavior.mootools');

      $doc->addScript("JQLIB");
      
      if ($insertjQueryNoConflict)
        $doc->addScriptDeclaration("JQNOCONFLICT");

      if (!$app->isAdmin()) {
        $app->set('jQuery', true);
      }
    }

    if ($app->isAdmin() && $jQueryInBackend == 1) {
      return;
    }

    if (($jQueryInFrontend == 2) || ($app->isAdmin() && $jQueryInBackend == 2)) { // use jQuery UI
      $doc->addScript("JQUILIB");
      $doc->addStyleSheet("JQUICSS");
    }
  }

  function onAfterRender() {

    $app =& JFactory::getApplication();

    $jQueryInFrontend = $this->params->get('jqueryinfrontend',1);		
    $jQueryInBackend = $this->params->get('jqueryinbackend',0);

    $removeAlljQueryNoConflict = $this->params->get('removealljquerynoconflict', 1);
    $insertjQueryNoConflict = $this->params->get('insertjquerynoconflict', 1);
    
    if ($app->isAdmin() && $jQueryInBackend == 0) {
      return;
    } 	

    $body =& JResponse::getBody();

    if ($jQueryInFrontend != 0 || ($app->isAdmin() && $jQueryInBackend != 0)) {		
      // remove all other references to jQuery library
      $body = preg_replace("#([\\\/a-zA-Z0-9_:\.-]*)jquery([0-9\.-]|min|pack)*?.js#", "", $body); // find jQuery versions
      $body = preg_replace("#([\\\/a-zA-Z0-9_:\.-]*)jquery[.-]noconflict\.js#", "", $body); // find potential jquery-noconflict.js
      $body = str_ireplace('<script src="" type="text/javascript"></script>', "", $body); // remove newly empty scripts

      if($removeAlljQueryNoConflict)
        $body = preg_replace("#jQuery\.noConflict\(\);#", "", $body); // remove all jQuery.noConflict();

      $body = preg_replace('#[^"]*?JQLIB#', $this->_jqpath, $body); // use our version of jQuery
      
      if($insertjQueryNoConflict)
        $body = preg_replace("#JQNOCONFLICT#", "jQuery.noConflict();", $body);
    }

    if ($app->isAdmin() && $jQueryInBackend == 1) {
      JResponse::setBody($body);
      return;
    } 

    if (($jQueryInFrontend == 2) || ($app->isAdmin() && $jQueryInBackend == 2)) {
      // remove all other references to jQuery UI library
      $body = preg_replace("#([\\\/a-zA-Z0-9_:\.-]*)jquery-ui([0-9\.-]|custom|min|pack)*?.js#", "", $body); // find jQuery UI versions
      $body = str_ireplace('<script src="" type="text/javascript"></script>', "", $body); // remove newly empty scripts
      $body = preg_replace('#[^"]*?JQUILIB#', $this->_jquipath, $body); // use our version of jQuery UI

      // remove all other references to jQuery UI stylesheets
      $body = preg_replace("#([\\\/a-zA-Z0-9_:\.-]*)jquery-ui([0-9\.-]|custom|min|pack)*?.css#", "", $body); // find jQuery UI CSS versions
      $body = str_ireplace('<link rel="stylesheet" href="" type="text/css" />', "", $body); // remove newly empty scripts
      $body = preg_replace('#[^"]*?JQUICSS#', $this->_jquicsspath, $body); // use our version of jQuery UI CSS
    }

    JResponse::setBody($body);

    return true;
  }
}